// q4pirc_dll.cpp : Defines the entry point for the DLL application.
// sYx66's Quake 4 IRC Ping Tool
//

#include <windows.h>
#include <stdio.h>

#include <winsock.h>
#include <io.h>
#pragma comment(lib, "wsock32.lib")

#define BUF_SIZE 10240
#define MAX_IRC_LENGTH 900

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

int __declspec(dllexport) FAR PASCAL GetInfo(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
	char buf[BUF_SIZE+4];
	int o,len,l=sizeof(struct sockaddr_in);
	struct sockaddr_in osin;
	struct hostent *he;
	fd_set fds;
	int rtnVal = 1;

	WSADATA wd;
	WSAStartup(0x0101,&wd);

	char server[1024];
	int port = 0;
	int res = 0;

	{
		char* c = strchr( data, ':' );
		if( c )	{
			strncpy( server, data, c - data );
			server[c - data] = '\0';
			port = atoi( c + 1 );
			res = 2;
		}
		else {
			goto cleanupWinSock;
		}
	}

	o=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);
	if((he=gethostbyname(server))==NULL) {
		goto cleanupSock;
	}
	osin.sin_family=AF_INET;
	osin.sin_port=htons(port);
	osin.sin_addr.s_addr=((struct in_addr *)(he->h_addr))->s_addr;

	DWORD timeStart = GetTickCount();
	DWORD timeEnd = 0;

	const char bufSend[] = { 0xff, 0xff, 0x67, 0x65, 0x74, 0x49, 0x6e, 0x66, 0x6f, 0x00, 0x02, 0x00, 0x00, 0x00 };
	sendto(o,bufSend,13,0,(struct sockaddr *)&osin,l);
	sendto(o,bufSend,13,0,(struct sockaddr *)&osin,l);

	FD_ZERO(&fds);
	FD_SET(o,&fds);

	//wait for some input on the socket
	timeval timeout;
	timeout.tv_sec = 0;
	timeout.tv_usec = 650000;

	if( select(o+1,&fds,NULL,NULL,&timeout) > 0 ) 
	{
		if( FD_ISSET(o, &fds) ) 
		{
			strcpy( data, "9999" );
			timeEnd = GetTickCount();

			if( (len = recvfrom(o,buf,BUF_SIZE,0,(struct sockaddr *)&osin,&l))== -1 ) {
				len = 0;
			}
			if( len > 0 )
			{
				int x, y = 0;
				int zero = 0;
				const unsigned char pStart[] = { 0, 0, 0 };
				int nStart = 0;
				const unsigned char pEnd[] = { 32, 1, 0, 0, 0 };
				int nEnd = 0;
				int state = 0;
				unsigned char scores[8];
				int s = 0;
				int lastY = -2;
				bool lastYvalid = false;
				int nameLen = 0;
				char tmp[256];

				// prepend the ping
				DWORD ping = timeEnd - timeStart;
				if( ping > 9999 )
					ping = 9999;
				sprintf(&data[y], "%04d", ping );
				y += 4;

				unsigned char* bufU = (unsigned char*)buf;
				for( x = 0; x < len && x < MAX_IRC_LENGTH; ++x )
				{
					if( nStart != -1 && bufU[x] == pStart[nStart] ) {
						nStart++;
						if( nStart == 3 ) {
							data[y] = '\xFF';
							data[y+1] = '\xFE';
							y += 2;
							nStart = -1;
						}
						continue;
					}
					else if( nStart != -1 ){
						x -= nStart;
						nStart = 0;
					}
					if( nStart == -1 && nEnd != -1 && bufU[x] == pEnd[nEnd] ) {
						nEnd++;
						if( nEnd == 5 ) {
							data[y] = '\xFE';
							y += 1;
							nEnd = -1;
							break;
						}
						continue;
					}
					else {
						x -= nEnd;
						nEnd = 0;
					}

					if( nStart == -1 )
					{/*
						if( !isalpha(bufU[x]) )
						{
							sprintf(&data[y], "_%02x", bufU[x]);
							y += 3;
						}
						else
						{
							data[y] = bufU[x];
							y++;
						}//*/
							//*
						if( s < 6 && state == 0 )
						{
							scores[s] = bufU[x];
							s++;
						}
						else if( bufU[x] == 0 )
						{
							if( state == 0)
							{
								if( s > 0 ) {
									sprintf( tmp, "%d", scores[2] * 256 + scores[1] );
									strcpy( &data[y], tmp );
									y += strlen( tmp );

									//sprintf(tmp,"%d %d %d %d %d %d", scores[0], scores[1], scores[2], scores[3], scores[4], scores[5], scores[6]);
									//MessageBox( mWnd, tmp, "q4p", MB_OK );
									s = 0;
								}
								state = 1;
							}
							else if( state == 1 )
							{
								if( nameLen == 0 ) {
									data[y] = ' ';
									y++;
								}
								state = 2;
							}
							else
							{
								if( nameLen == 0 ) {
									data[y] = ' ';
									y++;
								}
								state = 0;
							}
							data[y] = '\xFF';
							y++;
							nameLen = 0;
						}
						else 
						{
							nameLen++;
							if (x+4 < len && x+4 < MAX_IRC_LENGTH && 
								bufU[x] == 0x5E && bufU[x+1] == 'c' && (bufU[x+2] >= '0' && bufU[x+2] <= '9') &&
								(bufU[x+3] >= '0' && bufU[x+3] <= '9') && (bufU[x+4] >= '0' && bufU[x+4] <= '9') )
							{
								x += 4;
							}
							else if( x+3 < len && x+3 < MAX_IRC_LENGTH && 
								bufU[x] == 0x5E && bufU[x+1] == 0x20 && (bufU[x+2] >= '0' && bufU[x+2] <= '9') && bufU[x+3] == 0x20)
							{
								x += 3;
							}
							else if (x+1 < len && x+1 < MAX_IRC_LENGTH && 
								bufU[x] == 0x5E && (bufU[x+1] >= '0' && bufU[x+1] <= '9') )
							{
								x += 1;
							}
							else if( bufU[x] < 32 || bufU[x] > 127 )
							{
								sprintf(&data[y], "_%02x", bufU[x]);
								y += 3;
								//data[y] = '\xFF';
								//y++;
							}
							else
							{
								data[y] = bufU[x];
								y++;
							}
						}
						//*/
					}
					else
					{
						if (x+4 < len && x+4 < MAX_IRC_LENGTH && 
							bufU[x] == 0x5E && bufU[x+1] == 'c' && (bufU[x+2] >= '0' && bufU[x+2] <= '9') &&
							(bufU[x+3] >= '0' && bufU[x+3] <= '9') && (bufU[x+4] >= '0' && bufU[x+4] <= '9') )
						{
							x += 4;
						}
						else if( x+3 < len && x+3 < MAX_IRC_LENGTH && 
							bufU[x] == 0x5E && bufU[x+1] == 0x20 && (bufU[x+2] >= '0' && bufU[x+2] <= '9') && bufU[x+3] == 0x20)
						{
							x += 3;
						}
						else if (x+1 < len && x+1 < MAX_IRC_LENGTH && 
							bufU[x] == 0x5E && (bufU[x+1] >= '0' && bufU[x+1] <= '9') )
						{
							x += 1;
						}
						else if( bufU[x] == '>' )
						{
							lastYvalid = true;
						}
						else if( bufU[x] < 32 || bufU[x] > 127 )
						{
							if( lastYvalid && lastY + 1 == y ) {
								data[y] = '?';
								y++;
							}
							lastY = y;
							data[y] = '\xFF';
							y++;
						}
						else
						{
							data[y] = bufU[x];
							y++;
						}
					}
				}
				data[y] = '\0';
			}

			rtnVal = 3;
		} // if( FD_ISSET
	} // if( select

cleanupSock:;
	close(o);

cleanupWinSock:;
	WSACleanup();
	
	return rtnVal;
}

int __declspec(dllexport) FAR PASCAL IsQuakeActive(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
	if (FindWindow("Q4 WinConsole","Quake 4"))
		strcpy(data,"TRUE");
	else
		strcpy(data,"FALSE");
	return 3;
}
